/*
 * PgGraph_CP.java
 *
 * Created on December 5, 2004, 6:17 PM
 */

package Grapher.geom;
import java.awt.*;

import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
import Grapher.util.*;
/**
 * Control panel for PgGraph
 *
 * @author David
 * @version 1.0.122204
 */
public class PgGraph_CP extends PsPanel {
        protected	PgGraph                                 m_PgGraph;
        protected       PsPanel                                 m_pFunc;
	protected	PsPanel					m_pDomain;
        protected       PsPanel                                 m_pParams;
        
    /** Creates a new instance of PgGraph_CP */
    public PgGraph_CP() {
        super();
		if (getClass() == PgGraph_CP.class) {
			init();
		}
    }
    
    /** Initializes the control panel */
    public void init() {
		super.init();
		addTitle("Graph");
             
                m_pFunc = new PsPanel();
                add(m_pFunc);
                
                m_pParams = new PsPanel();
                add(m_pParams);
                
		m_pDomain = new PsPanel();
  		add(m_pDomain);
		
		addLine(1);
    }
    
    /** Sets parent and creates inspectors for the function and domain */
    public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PgGraph = (PgGraph)parent;
                
                setTitle("f(x,y) " + m_PgGraph.getName());
                
         //       m_pFunc.add(m_PgGraph.m_func2.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                m_pFunc.add(new PuFunc_IP(m_PgGraph.m_func2)); 
                m_pParams.add(m_PgGraph.m_params.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                m_pDomain.add(m_PgGraph.m_domain.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));

        }
    
    /** Sends updates.  Domain and function send their own updates, so this method does little */
    public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
	}
    
}
