/*
 * PgVectorField_CP.java
 *
 * Created on December 5, 2004, 6:20 PM
 */

package Grapher.geom;

import java.awt.*;

import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
import jv.objectGui.PsTabPanel;
import Grapher.util.*;
/**
 * Control Panel for PgVecFld
 *
 * @author David Lippman
 * @version 1.0.122204
 */
public class PgVecFld_CP extends PsPanel {
        protected	PgVecFld                                m_PgVecFld;
        protected       PsPanel                                 m_pFunc;
	protected	PsPanel					m_pDomain;
        protected       PsPanel                                 m_pParams;
        protected       PsPanel                                 m_pTab1;
        protected       PsTabPanel                      m_tabpanel;
    
    /** Creates a new instance of PgVecFld_CP */
    public PgVecFld_CP() {
        super();
        if (getClass() == PgVecFld_CP.class) {
            init();
        }
    }
    
    /** Initializes control panel */
     public void init() {
		super.init();
		addTitle("Graph");

                m_tabpanel = new PsTabPanel();
                add(m_tabpanel);
                m_tabpanel.init();

                m_pTab1 = new PsPanel();
                m_pTab1.setLayout(new GridLayout(2,1));
                
                m_pFunc = new PsPanel();
                m_pFunc.setLayout(new GridLayout(1, 1));
 //               add(m_pFunc);
                
                 m_pParams = new PsPanel();
           //     add(m_pParams);
                
		m_pDomain = new PsPanel();
 // 		add(m_pDomain);
		
		addLine(1);
    }
    
     /** Sets parent and adds inspectors for domain and function */
    public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PgVecFld = (PgVecFld)parent;
                
                setTitle("Vector Field " + m_PgVecFld.getName());
                
            //    m_pFunc.add(m_PgVecFld.m_func2.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                m_pFunc.add(new PuFunc_IP(m_PgVecFld.m_func2));   
                m_pParams.add(m_PgVecFld.m_params.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                m_pDomain.add(m_PgVecFld.m_domain.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));

                m_pTab1.add(m_pFunc);
                m_pTab1.add(m_pParams);
                m_tabpanel.addPanel("Function",m_pTab1);
                m_tabpanel.addPanel("Domain",m_pDomain);
                m_tabpanel.validate();
 
                
        }
    
    /** Handles update calls.  Domain and function send own updates, so this does little */
    public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
    }
}