/*
 * ImageSelection.java
 *
 * Created on December 20, 2004, 4:34 PM
 */

package Grapher.util;

import java.awt.*;
import java.awt.datatransfer.*;

/**
 *
 * @author David
 */
/*public class ImageSelection implements Transferable, ClipboardOwner {

	 static public DataFlavor imageFlavor;
 	private DataFlavor [] supportedFlavors = {imageFlavor};
 	private Image picture;
 

 
     public ImageSelection (Image parPicture) {
 
	 picture = parPicture;
	   try {
	    imageFlavor = new DataFlavor (Class.forName ("java.awt.Image"), "Image");
	    }
	   catch (ClassNotFoundException e) {
	    e.printStackTrace ();
	   }


	}

	public synchronized DataFlavor [] getTransferDataFlavors () {

	    return (supportedFlavors);

	}

	public boolean isDataFlavorSupported (DataFlavor parFlavor) {

	    return (parFlavor.equals (imageFlavor));

	}

	public synchronized Object getTransferData (DataFlavor parFlavor)
			   throws UnsupportedFlavorException {
	    if (parFlavor.equals (imageFlavor))
	    return (picture);
	   else
	    throw new UnsupportedFlavorException (imageFlavor);

	 }

	public void lostOwnership (Clipboard parClipboard, Transferable parTransferable) {

	    System.out.println ("Lost ownership");
	}
   }
*/
public class ImageSelection implements Transferable {
        private Image image;
    
        public ImageSelection(Image image) {
            this.image = image;
        }
    
        // Returns supported flavors
        public DataFlavor[] getTransferDataFlavors() {
            return new DataFlavor[]{DataFlavor.imageFlavor};
        }
    
        // Returns true if flavor is supported
        public boolean isDataFlavorSupported(DataFlavor flavor) {
            return DataFlavor.imageFlavor.equals(flavor);
        }
    
        // Returns image
        public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException {
            if (!DataFlavor.imageFlavor.equals(flavor)) {
                throw new UnsupportedFlavorException(flavor);
            }
            return image;
        }
    }
