/*
 * PuDomain_IP.java
 *
 * Created on December 5, 2004, 10:11 PM
 */

package Grapher.util;

import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
/**
 * Infopanel for PuDomain.  Displays domain sliders and checkboxes
 *
 * @author David Lippman
 * @version 1.0.122204
 */
public class PuDomain_IP extends PsPanel implements ItemListener {
        protected	PuDomain                                m_PuDomain;
	protected	PsPanel					m_pBounds;
        protected       PsPanel                                 m_pOptions;
        protected       PsPanel                                 m_pSlice;
        protected       PsPanel                                 m_pColorBy;
        
        protected       Checkbox                                m_cSclVecs;
        protected       Checkbox[]                              m_cShowSlice;
        protected       Checkbox                                m_cShowEdges;
        protected       CheckboxGroup                           m_ColorByGroup;
        protected       Checkbox[]                              m_cColorBys;

        
    /** Creates a new instance of PuDomain_IP */
    public PuDomain_IP() {
        super();
		if (getClass() == PuDomain_IP.class) {
			init();
		}
    }
    
    /** Initialize panel */
    public void init() {
                super.init();
		
                
                
                m_pSlice = new PsPanel();
                add (m_pSlice);
                
		m_pBounds = new PsPanel();
  		add(m_pBounds);
                
                m_pOptions = new PsPanel();
                add(m_pOptions);
		
              
                
	
    }
    
        /**
	 * Set parent of panel which supplies the data inspected by the panel.
         * Creates inspectors for domain sliders and checkboxes
	 */
	public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PuDomain = (PuDomain)parent;
                
                if (m_PuDomain.m_bIsVF) {
                    m_cSclVecs = new Checkbox("Scale Vecs to one length");
                    m_cSclVecs.addItemListener(this);
                    m_pOptions.add(m_cSclVecs);
                } 
                if (m_PuDomain.m_bAllowSlices && !m_PuDomain.m_bIsVF) {
                    m_cShowEdges = new Checkbox("Show Edges",true);
                    m_cShowEdges.addItemListener(this);
                    m_pOptions.add(m_cShowEdges);
                    m_pColorBy = new PsPanel(new GridLayout(1,3));
                    m_pColorBy.add(new Label("Color By:"));
                    m_ColorByGroup = new CheckboxGroup();
                    m_cColorBys = new Checkbox[2];
                    m_cColorBys[0] = new Checkbox("XYZ",m_ColorByGroup,true);
                    m_cColorBys[1] = new Checkbox("Z",m_ColorByGroup,false);
                    m_cColorBys[0].addItemListener(this);
                    m_pColorBy.add(m_cColorBys[0]);
                    m_cColorBys[1].addItemListener(this);
                    m_pColorBy.add(m_cColorBys[1]);
                    m_pOptions.add(m_pColorBy);
                }
                    
                m_pBounds.removeAll();
                for (int i = 0; i < m_PuDomain.numvariables; i++) {
                    m_pBounds.add(m_PuDomain.m_var[i][0].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                    m_pBounds.add(m_PuDomain.m_var[i][1].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                    if (m_PuDomain.m_numDiscr == -1) {
 //                    if (!m_PuDomain.m_bOneDiscr) {
                        m_pBounds.add(m_PuDomain.m_discr[i].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                    }
                 }
                 if (m_PuDomain.m_numDiscr == 1) {
//                if (m_PuDomain.m_bOneDiscr) {
                    m_pBounds.add(m_PuDomain.m_discr[0].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                }
               
                if (m_PuDomain.m_bIsVF) {
                    m_pBounds.add(m_PuDomain.m_veclength.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                }
                
                if (m_PuDomain.m_bAllowSlices) {
                    m_pSlice.setLayout(new GridLayout(1,m_PuDomain.numvariables));
                    m_cShowSlice = new Checkbox[m_PuDomain.numvariables];
                    for (int i = 0; i < m_PuDomain.numvariables; i++) { 
                        m_cShowSlice[i] = new Checkbox("Show " + m_PuDomain.m_varNames[i] +" slice");
                        m_cShowSlice[i].addItemListener(this);
                        m_pSlice.add(m_cShowSlice[i]);
                    }
                }
                

        }
	/**
	 * Update the panel whenever the parent has changed somewhere else.
	 * Method is invoked from the parent or its superclasses.
	 */
	public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
	}

        /** Handles checkbox clicks */
        public void itemStateChanged(ItemEvent event) {
		Object source = event.getSource();
                if (source == m_cSclVecs) {
                    m_PuDomain.m_bSclVecs = m_cSclVecs.getState();
//                    m_PuDomain.computeGeom();
                    m_PuDomain.update(m_PuDomain);
                }
                if (m_PuDomain.m_bAllowSlices) {
                    for (int i=0; i< m_PuDomain.numvariables;i++) {
                        if (source == m_cShowSlice[i]) { 
                            m_PuDomain.m_bShowSlice[i] = m_cShowSlice[i].getState();
                            m_PuDomain.m_var[i][1].setEnabled(!m_PuDomain.m_bShowSlice[i]);
                            if (m_PuDomain.m_numDiscr == -1) { 
                                m_PuDomain.m_discr[i].setEnabled(!m_PuDomain.m_bShowSlice[i]);
                            }
                            if (m_PuDomain.m_bShowSlice[i]) {
                                double temp = m_PuDomain.m_varValBU[i];
                                m_PuDomain.m_varValBU[i] = m_PuDomain.m_var[i][0].getValue();
                                m_PuDomain.m_var[i][0].setValue(temp);
                            } else {
                                double temp = m_PuDomain.m_var[i][0].getValue();
                                m_PuDomain.m_var[i][0].setValue(m_PuDomain.m_varValBU[i]);
                                m_PuDomain.m_varValBU[i] = temp;
                            }
                            m_PuDomain.update(m_PuDomain);
                        }
                    }
                    if (!m_PuDomain.m_bIsVF) {
                        for (int i=0; i<2; i++) {
                            if (source == m_cColorBys[i]) {
                                m_PuDomain.m_ColorBy = i;
                                m_PuDomain.update(m_PuDomain);
                            }
                        }
                        if (source == m_cShowEdges) {
                            m_PuDomain.m_bShowEdges = m_cShowEdges.getState();
                            m_PuDomain.update(m_PuDomain);
                        }
                    }
                }
	}
}
