/*
 * PuParams.java
 *
 * Created on October 29, 2005, 12:46 AM
 */

package Grapher.util;

import jv.object.PsObject;
import jv.function.PuFunction;
import jv.number.PuDouble;
import jv.number.PdColor;
import jv.number.PuInteger;
import jv.object.PsDebug;
import jv.vecmath.PdVector;
import jv.vecmath.PiVector;
/**
 * Class for parameter sliders.  Silly, but so I don't have to redo this for each geom class
 *
 * @author David
 * @version 1.0.281005
 */
public class PuParams extends PsObject {
  
        protected       PuDouble[]                      m_params;
        protected       int                             m_numparams;
        protected       String[]                        m_paramnames = {"a","b","c","d","e","f","g","h"};
        
    /** Creates a new instance of PuParams */
    public PuParams() {
        super();
        if (getClass() == PuParams.class) {
            
        }
    }
    
    public void init(int numparams) {
        m_numparams = numparams;
        super.init();
        
        m_params = new PuDouble[numparams];
        
        for (int i=0; i<m_numparams; i++) {
            m_params[i] = new PuDouble("Parameter",this);
            m_params[i].setSymbol(m_paramnames[i]);
            m_params[i].setDefBounds(-10,10,.1,1);
            m_params[i].setDefValue(1.0);
            m_params[i].init();
        }   
    }
    
    public void registerWith(PuFunction m_func) {
        for (int i=0; i<m_numparams; i++) {
            m_func.addParameter(m_params[i]);
        }   
    }
    
    public double getParam(int n) {
        return m_params[n].getValue();
    }
    
    /** Handles update events.  Called when domain sliders are changed */
    public boolean update(Object event) {
                if (event == this) {
                        super.update(this);
                        return true;
		} else if (event == m_params) {
                        
			update(this);
			return true;
		} 
                 
                super.update(this);
                return true;
    }
}
